d("myAddressBookView", ['util'], function (UTIL, myAddressBookView) {

    return {
        extendmyAddressBookView: function () {

            CCRZ.pubSub.once('view:myAddressBookView:refresh', function (myAddressBookView) {
                UTIL.hideLoader();
                console.log('override view myAddressBookView');
                myAddressBookView.saveEntity = function (event) {

                    var objLink = $(event.target);
                    var id = objLink.data("id");
                    var v = this;
                    var formData = form2js('editAddressForm', '.', false, function (node) {
                    }, false, true);
                    formData.addressBean.country = 'United States';
                    formData.addressBean.countryISOCode = 'US';

                    v.initValidation();

                    var isValid = false;
                    isValid = $("#editAddressForm").valid();
                    if (isValid) {
                        UTIL.showLoader();
                        this.closeModal(id);
                        this.addressList.editEntity(id, formData, function (id) {
                            v.addressList.fetch(function () {
                                v.render();
                            });
                        });
                    }
                }

                myAddressBookView.initValidation = function () {
                    $.validator.addMethod( "regex", function(value, element, regexp) {
                        return this.optional(element) || regexp.test(value);
                        },
                        "Please check your input."
                    );
                    $('#editAddressForm').each(function () {
                        $(this).validate({
                            invalidHandler: function (event1, validator1) {
                                CCRZ.handleValidationErrors(event1, validator1, 'addrModal-messagingSection-Error', false);
                            },
                            //TODO Client side validation for item group name?
                            rules: {
                                "addressBean.firstName": {
                                    minlength: 3,
                                    regex: /^-?[a-zA-Z]{3,}[a-zA-Z0-9\s]*$/,
                                    required: true
                                },
                                "addressBean.lastName": {
                                    minlength: 3,
                                    regex: /^-?[a-zA-Z]{3,}[a-zA-Z0-9\s]*$/,
                                    required: true
                                },
                                "addressBean.address1": {
                                    minlength: 3,
                                    regex: /^-?[a-zA-Z0-9]{3,}[a-zA-Z0-9\s]*$/,
                                    required: true
                                },
                                "addressBean.city": {
                                    minlength: 3,
                                    regex: /^-?[a-zA-Z]{3,}[a-zA-Z\s]*$/,
                                    required: true
                                },
                                "addressBean.postalCode": {
                                    required: true,
                                    minlength: 5,
                                    maxlength: 10,
                                    regex: /^(\d{5}|\d{5}-\d{4})$/
                                },
                                "addressBean.homePhone": {
                                    minlength: 10,
                                    maxlength: 10,
                                    required: true,
                                    regex: /^(\d{3})[- ]?(\d{3})[- ]?(\d{4})$/
                                },
                                "addressBean.email": {
                                    regex: /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/,
                                    required: true
                                }
                            },
                            messages: {
                                "addressBean.firstName": {
                                    regex: 'LPM_BB_First_Name_Regex',
                                    required: 'LPM_BB_First_Name'
                                },
                                "addressBean.lastName": {
                                    regex: 'LPM_BB_Last_Name_Regex',
                                    required: 'LPM_BB_Last_Name'
                                },
                                "addressBean.address1": {
                                    regex: "LPM_BB_Address_Line_Regex",
                                    required: "LPM_BB_Address_Line"
                                },
                                "addressBean.city": {
                                    regex: "LPM_BB_City_Name_Regex",
                                    required: "LPM_BB_City_Name"
                                },
                                "addressBean.postalCode": {
                                    regex: 'LPM_BB_Postal_Code_Regex',
                                    required: 'LPM_BB_Postal_Code'
                                },
                                "addressBean.email": {
                                    regex: 'LPM_BB_Email_Address_Regex',
                                    required: 'LPM_BB_Email_Address'
                                },
                                "addressBean.homePhone": {
                                    regex: 'LPM_BB_Phone_Number_Regex',
                                    required: 'LPM_BB_Phone_Number'
                                }
                            },
                            errorPlacement: function (error, element) {
                            }
                        });
                    });

                    $('#buyerInfo').validate({
                        invalidHandler: function (event2, validator2) {
                            CCRZ.handleValidationErrors(event2, validator2, 'messagingSection-Error', false);
                        },
                        //TODO Client side validation for item group name?
                        rules: {
                            "buyerFirstName": {
                                required: CCRZ.getPageConfig('Info.ReqFirstName', true)
                            },
                            "buyerLastName": {
                                required: CCRZ.getPageConfig('Info.ReqLastName', true)
                            },
                            "buyerEmail": {
                                required: CCRZ.getPageConfig('Info.ReqEmail', true),
                                email: true
                            },
                            "buyerPhone": {
                                required: CCRZ.getPageConfig('Info.ReqPhone', false)
                            }
                        },
                        messages: {
                            buyerFirstName: {
                                required: "MISSING_FIRST_NAME"
                            },
                            buyerLastName: {
                                required: "MISSING_LAST_NAME"
                            },
                            buyerEmail: {
                                required: "MISSING_EMAIL_ADDRESS",
                                email: "FORMATTING_EMAIL"
                            },
                            buyerPhone: {
                                required: "MISSING_PHONE"
                            }
                        },
                        errorPlacement: function (error, element) {
                        }
                    });

                };
                /*myOrdersView.reorder = function(event){
                    UTIL.showLoader();
                    var objLink = $(event.target);
                    var id = objLink.data("id");
                    this.orderList.reorder(id, function(newCartId){
                     cartDetails(newCartId);
                    });
                }*/

                myAddressBookView.delegateEvents();
                myAddressBookView.render();
            });

            CCRZ.pubSub.on('view:myAddressBookView:refresh', function (myAddressBookView) {
                UTIL.hideLoader();
            });
        },


    }
});



